diff --git a/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java b/src/main/java/net/minecraft/client/gui/PaintingPickerScreen.java
similarity index 86%
rename from src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
rename to src/main/java/net/minecraft/client/gui/PaintingPickerScreen.java
index 11cae75ca..3361b836f 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
+++ b/src/main/java/net/minecraft/client/gui/PaintingPickerScreen.java
@@ -14,15 +14,15 @@ import java.util.List;
 import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL11.GL_BLEND;
 
-public class GuiPaintingPicker
-    extends GuiScreen
+public class PaintingPickerScreen
+    extends Screen
 {
     private final Player player;
     private final List<ArtEntry> artEntries = new ArrayList<>();
     private ArtType centerArt = ArtType.Kebab;
     private int tallestSize = 0;
 
-    public GuiPaintingPicker(Player player)
+    public PaintingPickerScreen(Player player)
     {
         this.player = player;
         for (ArtType art : ArtType.values){
@@ -38,9 +38,9 @@ public class GuiPaintingPicker
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    public void render(int xm, int ym, float partialTick)
     {
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
 
         float dWheel = Mouse.getDWheel();
         if (dWheel < 0)
@@ -54,23 +54,23 @@ public class GuiPaintingPicker
             updateArtEntries();
         }
 
-        drawPaintings(width, height, mouseX, mouseY);
+        drawPaintings(width, height, xm, ym);
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+    public void mouseClicked(int mx, int my, int buttonNum)
     {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
         int scale = getScale(width, height);
 
-        if (mouseButton == 0)
+        if (buttonNum == 0)
         {
             for (ArtEntry artEntry : artEntries)
             {
-                if (mouseX >= artEntry.x && mouseX <= artEntry.x + artEntry.art.sizeX * scale && mouseY >= artEntry.y && mouseY <= artEntry.y + artEntry.art.sizeY * scale)
+                if (mx >= artEntry.x && mx <= artEntry.x + artEntry.art.sizeX * scale && my >= artEntry.y && my <= artEntry.y + artEntry.art.sizeY * scale)
                 {
                     mc.playerController.setPaintingType(artEntry.art);
-                    mc.displayGuiScreen(null);
+                    mc.displayScreen(null);
                     break;
                 }
             }
@@ -126,8 +126,8 @@ public class GuiPaintingPicker
 
         glEnable(GL_TEXTURE_2D);
 
-        drawString(fontRenderer, centerArt.title, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 4, 0xFFFFFFFF);
-        drawString(fontRenderer, centerArt.artist, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 16, 0x7F7F7F7F);
+        drawString(font, centerArt.title, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 4, 0xFFFFFFFF);
+        drawString(font, centerArt.artist, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 16, 0x7F7F7F7F);
 
         glEnable(GL_BLEND);
         glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
diff --git a/src/main/java/net/minecraft/client/gui/GuiIngameMenu.java b/src/main/java/net/minecraft/client/gui/PauseScreen.java
similarity index 62%
rename from src/main/java/net/minecraft/client/gui/GuiIngameMenu.java
rename to src/main/java/net/minecraft/client/gui/PauseScreen.java
index 42bdf4baf..deb18a47e 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngameMenu.java
+++ b/src/main/java/net/minecraft/client/gui/PauseScreen.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.achievements.GuiAchievements;
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.achievements.AchievementsScreen;
+import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.gui.guidebook.PageManager;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
-import net.minecraft.client.gui.options.GuiOptions;
+import net.minecraft.client.gui.options.OptionsScreen;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
@@ -19,10 +19,10 @@ import net.minecraft.client.input.InputType;
 //            StatList, StatFileWriter, World, GuiMainMenu, 
 //            GuiAchievements, GuiStats, MathHelper
 
-public class GuiIngameMenu extends GuiScreen
+public class PauseScreen extends Screen
 {
 
-    public GuiIngameMenu()
+    public PauseScreen()
     {
         updateCounter2 = 0;
         updateCounter = 0;
@@ -33,34 +33,34 @@ public class GuiIngameMenu extends GuiScreen
     {
         I18n i = I18n.getInstance();
         updateCounter2 = 0;
-        controlList.clear();
+        buttons.clear();
         byte byte0 = -16;
-        controlList.add(new GuiButton(1, width / 2 - 100, height / 4 + 120 + byte0, i.translateKey("gui.ingame_menu.button.save_and_quit")));
+        buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 120 + byte0, i.translateKey("gui.ingame_menu.button.save_and_quit")));
         if(mc.isMultiplayerWorld())
         {
-            controlList.get(0).displayString = i.translateKey("gui.ingame_menu.button.disconnect");
+            buttons.get(0).displayString = i.translateKey("gui.ingame_menu.button.disconnect");
         }
-        controlList.add(new GuiButton(4, width / 2 - 100, height / 4 + 24 + byte0, i.translateKey("gui.ingame_menu.button.back_to_game")));
-        controlList.add(new GuiButton(0, width / 2 - 100, height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.options")));
-        GuiButton photoModeButton = new GuiButton(7, width / 2 + 2, height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.photo_mode"));
-        controlList.add(photoModeButton);
+        buttons.add(new ButtonElement(4, width / 2 - 100, height / 4 + 24 + byte0, i.translateKey("gui.ingame_menu.button.back_to_game")));
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.options")));
+        ButtonElement photoModeButton = new ButtonElement(7, width / 2 + 2, height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.photo_mode"));
+        buttons.add(photoModeButton);
         if (photoModeDisabled)
         {
             photoModeButton.enabled = false;
         }
-        controlList.add(new GuiButton(5, width / 2 - 100, height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.achievements")));
-        controlList.add(new GuiButton(6, width / 2 + 2, height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.statistics")));
-        GuiButton debugButton = new GuiButton(9, width - 8, height - 8, 8, 8, "");
+        buttons.add(new ButtonElement(5, width / 2 - 100, height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.achievements")));
+        buttons.add(new ButtonElement(6, width / 2 + 2, height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.statistics")));
+        ButtonElement debugButton = new ButtonElement(9, width - 8, height - 8, 8, 8, "");
         debugButton.visible = false;
-        controlList.add(debugButton);
+        buttons.add(debugButton);
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(button.id == 0)
         {
-            mc.displayGuiScreen(new GuiOptions(this));
+            mc.displayScreen(new OptionsScreen(this));
         }
         if(button.id == 1)
         {
@@ -71,14 +71,14 @@ public class GuiIngameMenu extends GuiScreen
                 Registries.RECIPES = Registries.RECIPES_LOCAL_COPY;
                 SearchPage.searchField.setText("");
                 PageManager.searchQuery = SearchQuery.resolve(SearchPage.searchField.getText());
-                GuiGuidebook.getPageManager().updatePages();
+                GuidebookScreen.getPageManager().updatePages();
             }
             mc.changeWorld(null);
-            mc.displayGuiScreen(new GuiMainMenu());
+            mc.displayScreen(new MainMenuScreen());
         }
         if(button.id == 4)
         {
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
             mc.setIngameFocus();
             
             //Cancel A press so you dont jump because you hold the jump button
@@ -87,18 +87,18 @@ public class GuiIngameMenu extends GuiScreen
         }
         if(button.id == 5)
         {
-            mc.displayGuiScreen(new GuiAchievements(this, mc.statsCounter));
+            mc.displayScreen(new AchievementsScreen(this, mc.statsCounter));
         }
         if(button.id == 6)
         {
-            mc.displayGuiScreen(new GuiStats(this, mc.statsCounter));
+            mc.displayScreen(new StatsScreen(this, mc.statsCounter));
         }
         if (button.id == 7)
         {
-            mc.displayGuiScreen(new GuiPhotoMode());
+            mc.displayScreen(new PhotoModeScreen());
         }
         if(button.id == 9){
-            mc.displayGuiScreen(new GuiOptions(this, OptionsPages.DEBUG));
+            mc.displayScreen(new OptionsScreen(this, OptionsPages.DEBUG));
         }
     }
 
@@ -110,12 +110,12 @@ public class GuiIngameMenu extends GuiScreen
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
         I18n i = I18n.getInstance();
-        drawDefaultBackground();
+        renderBackground();
         if(mc == null || mc.theWorld == null) {
-        	mc.displayGuiScreen(null);
+        	mc.displayScreen(null);
         	return;
         }
         boolean isSaving = !mc.theWorld.pauseScreenSave(updateCounter2++);
@@ -124,12 +124,12 @@ public class GuiIngameMenu extends GuiScreen
             float f1 = ((float)(updateCounter % 10) + partialTick) / 10F;
             f1 = MathHelper.sin(f1 * MathHelper.PI * 2.0F) * 0.2F + 0.8F;
             int k = (int)(255F * f1);
-            drawString(fontRenderer, i.translateKey("gui.ingame_menu.label.saving"), 8, height - 16, k << 16 | k << 8 | k);
+            drawString(font, i.translateKey("gui.ingame_menu.label.saving"), 8, height - 16, k << 16 | k << 8 | k);
         }
-        drawStringCentered(fontRenderer, i.translateKey("gui.ingame_menu.label.title"), width / 2, 40, 0xffffff);
+        drawStringCentered(font, i.translateKey("gui.ingame_menu.label.title"), width / 2, 40, 0xffffff);
         String score = TextFormatting.YELLOW.toString() + mc.thePlayer.getScore();
-        drawStringCentered(fontRenderer, i.translateKeyAndFormat("gui.ingame_menu.label.score", score), width / 2, 56, 0xfefefe);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        drawStringCentered(font, i.translateKeyAndFormat("gui.ingame_menu.label.score", score), width / 2, 56, 0xfefefe);
+        super.render(xm, ym, partialTick);
     }
 
     private int updateCounter2;
diff --git a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java b/src/main/java/net/minecraft/client/gui/PhotoModeScreen.java
similarity index 78%
rename from src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
rename to src/main/java/net/minecraft/client/gui/PhotoModeScreen.java
index b79ddf22d..ec048745e 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
+++ b/src/main/java/net/minecraft/client/gui/PhotoModeScreen.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.season.Season;
@@ -19,21 +19,21 @@ import net.minecraft.core.util.helper.ScreenShot;
 import java.io.File;
 import java.util.Locale;
 
-public class GuiPhotoMode extends GuiScreen
+public class PhotoModeScreen extends Screen
 {
-    private GuiButton buttonRotateLeft;
-    private GuiButton buttonRotateRight;
-    private GuiButton buttonCenterScreen;
-    private GuiSlider sliderTimeOfDay;
-    private GuiButton buttonSeason;
-    private GuiButton buttonTakeScreenshot;
-    private GuiListenerButton buttonOpenScreenshotFolder;
-    private GuiButton buttonExit;
-    private GuiSlider sliderFog;
-    private GuiSlider sliderTilt;
-    private GuiButton buttonShaders;
-    private GuiSlider sliderIntensity;
-    private GuiButton buttonShowPlayer;
+    private ButtonElement buttonRotateLeft;
+    private ButtonElement buttonRotateRight;
+    private ButtonElement buttonCenterScreen;
+    private SliderElement sliderTimeOfDay;
+    private ButtonElement buttonSeason;
+    private ButtonElement buttonTakeScreenshot;
+    private ListenerButtonElement buttonOpenScreenshotFolder;
+    private ButtonElement buttonExit;
+    private SliderElement sliderFog;
+    private SliderElement sliderTilt;
+    private ButtonElement buttonShaders;
+    private SliderElement sliderIntensity;
+    private ButtonElement buttonShowPlayer;
 
     private final long originalTOD;
     private long desiredTOD = -1;
@@ -79,7 +79,7 @@ public class GuiPhotoMode extends GuiScreen
     
     protected boolean showHelpText = true;
 
-    public GuiPhotoMode()
+    public PhotoModeScreen()
     {
         Minecraft mc = Minecraft.getMinecraft(this);
 
@@ -129,12 +129,12 @@ public class GuiPhotoMode extends GuiScreen
 
         I18n i18n = I18n.getInstance();
 
-        buttonExit = new GuiButton(5, 0, 0, 20, 20, "X");
+        buttonExit = new ButtonElement(5, 0, 0, 20, 20, "X");
 
-        buttonRotateLeft = new GuiButton(0, width / 2 - 59 - 2 - 20, height - 20, 20, 20, "<");
-        buttonRotateRight = new GuiButton(1, width / 2 + 59 + 2 + 1, height - 20, 20, 20, ">");
-        buttonTakeScreenshot = new GuiButton(4, width / 2 - 59, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
-        buttonOpenScreenshotFolder = (GuiListenerButton) new GuiListenerButton(30, buttonTakeScreenshot.getWidth() + buttonTakeScreenshot.getX() + 1, buttonTakeScreenshot.getY(), 20, 20, "")
+        buttonRotateLeft = new ButtonElement(0, width / 2 - 59 - 2 - 20, height - 20, 20, 20, "<");
+        buttonRotateRight = new ButtonElement(1, width / 2 + 59 + 2 + 1, height - 20, 20, 20, ">");
+        buttonTakeScreenshot = new ButtonElement(4, width / 2 - 59, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
+        buttonOpenScreenshotFolder = (ListenerButtonElement) new ListenerButtonElement(30, buttonTakeScreenshot.getWidth() + buttonTakeScreenshot.getX() + 1, buttonTakeScreenshot.getY(), 20, 20, "")
             .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder");
         buttonOpenScreenshotFolder.setActionListener(() -> {
             File f = new File(mc.getMinecraftDir(), "screenshots");
@@ -142,50 +142,50 @@ public class GuiPhotoMode extends GuiScreen
             Utils.openDirectory(f);
         });
 
-        buttonCenterScreen = new GuiButton(10, width - 120, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
-        buttonShowPlayer = new GuiButton(11, width - 120, 0, 120, 20, "");
-        sliderTimeOfDay = new GuiSlider(2, width - 120, 0, 120, 20, "", 0.0f);
-        buttonSeason = new GuiButton(3, width - 120, 0, 120, 20, "");
-        sliderFog = new GuiSlider(6, width - 120, 0, 120, 20, "", 1.0f);
-        sliderTilt = new GuiSlider(7, width - 120, 0, 120, 20, "", 30f / 90f);
+        buttonCenterScreen = new ButtonElement(10, width - 120, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
+        buttonShowPlayer = new ButtonElement(11, width - 120, 0, 120, 20, "");
+        sliderTimeOfDay = new SliderElement(2, width - 120, 0, 120, 20, "", 0.0f);
+        buttonSeason = new ButtonElement(3, width - 120, 0, 120, 20, "");
+        sliderFog = new SliderElement(6, width - 120, 0, 120, 20, "", 1.0f);
+        sliderTilt = new SliderElement(7, width - 120, 0, 120, 20, "", 30f / 90f);
         if(Shaders.enableShaders) {
-            buttonShaders = new GuiButton(8, width - 120, 0, 120, 20, "");
-            sliderIntensity = new GuiSlider(9, width - 120, 0, 120, 20, "", intensityValue);
+            buttonShaders = new ButtonElement(8, width - 120, 0, 120, 20, "");
+            sliderIntensity = new SliderElement(9, width - 120, 0, 120, 20, "", intensityValue);
             
             if (photoModeRenderer.getActiveShader() == null) {
                 sliderIntensity.enabled = false;
             }
         }
 
-        controlList.add(buttonCenterScreen);
-        controlList.add(buttonShowPlayer);
-        controlList.add(sliderTilt);
+        buttons.add(buttonCenterScreen);
+        buttons.add(buttonShowPlayer);
+        buttons.add(sliderTilt);
         
         if(Shaders.enableShaders) {
             mc.setRenderer(photoModeRenderer);
         }
 
         if (!mc.theWorld.isClientSide) {
-            controlList.add(sliderTimeOfDay);
-            controlList.add(sliderFog);
-            controlList.add(buttonSeason);
+            buttons.add(sliderTimeOfDay);
+            buttons.add(sliderFog);
+            buttons.add(buttonSeason);
         }
         
         if(Shaders.enableShaders) {
-            controlList.add(buttonShaders);
-            controlList.add(sliderIntensity);
+            buttons.add(buttonShaders);
+            buttons.add(sliderIntensity);
         }
 
         int i=0;
-        for(GuiButton button : controlList) {
+        for(ButtonElement button : buttons) {
             button.yPosition = i++ * 21;
         }
 
-        controlList.add(buttonRotateLeft);
-        controlList.add(buttonRotateRight);
-        controlList.add(buttonTakeScreenshot);
-        controlList.add(buttonOpenScreenshotFolder);
-        controlList.add(buttonExit);
+        buttons.add(buttonRotateLeft);
+        buttons.add(buttonRotateRight);
+        buttons.add(buttonTakeScreenshot);
+        buttons.add(buttonOpenScreenshotFolder);
+        buttons.add(buttonExit);
 
         if (desiredTOD == -1)
         {
@@ -202,7 +202,7 @@ public class GuiPhotoMode extends GuiScreen
     }
 
     @Override
-    public void onClosed()
+    public void removed()
     {
         mc.theWorld.setWorldTimeUpdateTicks(originalTOD);
         
@@ -214,7 +214,7 @@ public class GuiPhotoMode extends GuiScreen
     }
 
     @Override
-    protected void buttonPressed(GuiButton button)
+    protected void buttonClicked(ButtonElement button)
     {
         if (button == buttonRotateLeft)
         {
@@ -249,7 +249,7 @@ public class GuiPhotoMode extends GuiScreen
         }
         else if (button == buttonExit)
         {
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
         }
         else if (button == buttonShaders)
         {
@@ -277,29 +277,29 @@ public class GuiPhotoMode extends GuiScreen
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+    public void mouseClicked(int mx, int my, int buttonNum)
     {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
 
-        if (!isMouseDown && selectedButton == null)
+        if (!isMouseDown && clickedButton == null)
         {
             showHelpText = false;
             isMouseDown = true;
-            mouseDownX = mouseX;
-            mouseDownY = mouseY;
+            mouseDownX = mx;
+            mouseDownY = my;
             lastEndPanX = iPanX;
             lastEndPanY = iPanY;
             lastEndRotation = iRotation;
-            this.mouseButton = mouseButton;
+            this.mouseButton = buttonNum;
         }
     }
 
     @Override
-    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton)
+    public void mouseReleased(int mx, int my, int buttonNum)
     {
-        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+        super.mouseReleased(mx, my, buttonNum);
 
-        if (isMouseDown && mouseButton != -1)
+        if (isMouseDown && buttonNum != -1)
         {
             isMouseDown = false;
         }
@@ -308,19 +308,19 @@ public class GuiPhotoMode extends GuiScreen
             if (this.mouseButton == 0)
             {
                 float div = (float)Math.pow(2, iZoom) / 3;
-                iPanXGoal = lastEndPanX + (mouseX - mouseDownX) / div;
-                iPanYGoal = lastEndPanY + (mouseY - mouseDownY) / div;
+                iPanXGoal = lastEndPanX + (mx - mouseDownX) / div;
+                iPanYGoal = lastEndPanY + (my - mouseDownY) / div;
             }
             else
             {
-                iRotationGoal = lastEndRotation + (mouseX - mouseDownX) / 128f;
+                iRotationGoal = lastEndRotation + (mx - mouseDownX) / 128f;
             }
         }
     }
 
     protected long lastUpdateTime = 0;
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    public void render(int xm, int ym, float partialTick)
     {
         GL11.glViewport(0, 0, mc.resolution.width, mc.resolution.height);
         GL11.glMatrixMode(GL11.GL_PROJECTION);
@@ -386,7 +386,7 @@ public class GuiPhotoMode extends GuiScreen
 
         if (!shouldScreenshot)
         {
-            super.drawScreen(mouseX, mouseY, partialTick);
+            super.render(xm, ym, partialTick);
         }
         else
         {
@@ -432,7 +432,7 @@ public class GuiPhotoMode extends GuiScreen
             }
         }
         
-        if (showHelpText) drawStringCentered(fontRenderer, I18n.getInstance().translateKey("gui.photo_mode.label.mouse_hint"), width / 2, height - 36, 0xFFFFFF);
+        if (showHelpText) drawStringCentered(font, I18n.getInstance().translateKey("gui.photo_mode.label.mouse_hint"), width / 2, height - 36, 0xFFFFFF);
     }
 
     private void updateButtonsText()
diff --git a/src/main/java/net/minecraft/client/gui/Screen.java b/src/main/java/net/minecraft/client/gui/Screen.java
new file mode 100644
index 000000000..154e71dc7
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/Screen.java
@@ -0,0 +1,210 @@
+package net.minecraft.client.gui;
+
+import static org.lwjgl.opengl.GL11.*;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.util.debug.DebugRender;
+import net.minecraft.client.input.InputType;
+
+import net.minecraft.core.sound.SoundCategory;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+
+public abstract class Screen extends Gui {
+    protected Minecraft mc;
+    public int width;
+    public int height;
+    public List<ButtonElement> buttons;
+    public boolean passEvents;
+    protected Font font;
+    protected ButtonElement clickedButton;
+    final Screen parentScreen;
+
+    public Screen(Screen parent) {
+        buttons = new ArrayList<>();
+        passEvents = false;
+        clickedButton = null;
+        parentScreen = parent;
+    }
+
+    public Screen() {
+        this(null);
+    }
+
+    public Screen getParentScreen() {
+        return parentScreen;
+    }
+
+    public <E extends ButtonElement> E add(E button) {
+        buttons.add(button);
+        return button;
+    }
+
+    public void render(int xm, int ym, float partialTick) {
+        for (int i = 0; i < buttons.size(); i++) {
+            ButtonElement button = buttons.get(i);
+            button.drawButton(mc, xm, ym);
+        }
+    }
+
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey == Keyboard.KEY_BACK) {
+            mc.displayScreen(parentScreen);
+        }
+        if (eventKey == Keyboard.KEY_ESCAPE) {
+            mc.displayScreen(null);
+        }
+    }
+
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        if (buttonNum == 0) {
+            for (ButtonElement button : buttons) {
+                if (button.mouseClicked(mc, mx, my) && button.playSound) {
+                    clickedButton = button;
+                    mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                    if (button.listener != null) {
+                        button.listener.listen(button);
+                    } else {
+                        buttonClicked(button);
+                    }
+                    return;
+                }
+            }
+
+        }
+    }
+
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        if (clickedButton != null && buttonNum == 0) {
+            buttonReleased(clickedButton);
+            clickedButton.mouseReleased(mx, my);
+            clickedButton = null;
+        }
+    }
+
+    protected void buttonClicked(ButtonElement button) {
+    }
+
+    protected void buttonReleased(ButtonElement button) {
+    }
+
+    public void init(Minecraft mc, int width, int height) {
+        this.mc = mc;
+        font = mc.font;
+        this.width = width;
+        this.height = height;
+        buttons.clear();
+        init();
+    }
+
+    public void init() {
+    }
+
+    public void updateEvents() {
+        int mouseX = (Mouse.getEventX() * width) / mc.resolution.width;
+        int mouseY = height - (Mouse.getEventY() * height) / mc.resolution.height - 1;
+
+        while (Mouse.next()) {
+            if (mc.inputType == InputType.CONTROLLER) break;
+
+            if (Mouse.getEventButtonState()) {
+                mouseClicked(mouseX, mouseY, Mouse.getEventButton());
+            } else {
+                mouseReleased(mouseX, mouseY, Mouse.getEventButton());
+            }
+        }
+        while (Keyboard.next()) {
+            if (Keyboard.getEventKeyState() && mc.gameSettings.showFrameTimes.value && DebugRender.keyPressed(Keyboard.getEventKey())) {
+                continue;
+            }
+            int eventKey = Keyboard.getEventKey();
+            char eventChar = Keyboard.getEventCharacter();
+            if (eventKey == 0 && Character.isDefined(eventChar)) {
+                keyPressed(eventChar, eventKey, mouseX, mouseY);
+                return;
+            }
+            if (Keyboard.getEventKeyState()) {
+                if (eventKey == Keyboard.KEY_F11) {
+                    mc.gameWindow.toggleFullscreen();
+                    return;
+                }
+                keyPressed(eventChar, eventKey, mouseX, mouseY);
+            }
+        }
+    }
+
+    public void tick() {
+    }
+
+    public void removed() {
+    }
+
+    public void renderBackground() {
+        if (mc.theWorld != null) {
+            int color = mc.gameSettings.guiBackgroundColor.value.getARGB();
+            drawGradientRect(0, 0, width, height, color, color);
+        } else {
+            renderTexturedBackground();
+        }
+    }
+
+    public void renderTexturedBackground() {
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_FOG);
+        Tessellator tessellator = Tessellator.instance;
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        float f = 32F;
+        tessellator.startDrawingQuads();
+        tessellator.setColorOpaque_I(0x404040);
+        tessellator.addVertexWithUV(0.0D, height, 0.0D, 0.0D, (float) height / f);
+        tessellator.addVertexWithUV(width, height, 0.0D, (float) width / f, (float) height / f);
+        tessellator.addVertexWithUV(width, 0.0D, 0.0D, (float) width / f, 0);
+        tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0);
+        tessellator.draw();
+    }
+
+    public void drawControllerCursor() {
+        glDisable(GL_DEPTH_TEST);
+        glEnable(GL_BLEND);
+        glColor3d(1.0, 1.0, 1.0);
+        drawGuiTexture(mc.textureManager, (int) (mc.controllerInput.cursorX - 8), (int) (mc.controllerInput.cursorY - 8), 16, 16, "/assets/minecraft/textures/gui/controller/cursor.png");
+        glDisable(GL_BLEND);
+    }
+
+    public void controllerInput(ControllerInput controller) {
+        guiSpecificControllerInput(controller);
+        playControllerButtonSound(controller);
+    }
+
+    public void playControllerButtonSound(ControllerInput controller) {
+        if (controller.buttonA.pressedThisFrame() || controller.buttonX.pressedThisFrame() || controller.buttonY.pressedThisFrame()) {
+            mc.sndManager.playSound("random.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+        }
+        if (controller.buttonB.pressedThisFrame()) {
+            mc.sndManager.playSound("random.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+        }
+    }
+
+    public void guiSpecificControllerInput(ControllerInput controller) {
+
+    }
+
+    public boolean isPauseScreen() {
+        return true;
+    }
+
+    public void selectNextField() {
+    }
+
+    public void updateFont() {
+        this.font = mc.font;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java b/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
index ca81ae218..744dce911 100644
--- a/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
+++ b/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
@@ -156,7 +156,7 @@ public abstract class ScrolledSelectionList {
         GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glDisable(GL11.GL_FOG);
         Tessellator tessellator = Tessellator.instance;
-        minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float f1 = 32F;
         tessellator.startDrawingQuads();
@@ -268,7 +268,7 @@ public abstract class ScrolledSelectionList {
 
     private void renderHoleBackground(int y0, int y1, int a0, int a1) {
         Tessellator tessellator = Tessellator.instance;
-        minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float f = 32F;
         tessellator.startDrawingQuads();
